%return the slope and intersection of axis and the ratio of axis cutting convex hull
%Author: Rongju Sun
%Email: rongjusun@gmail.com
%Date: Dec, 2014
%@Peking University, China

function kd = fig_axis(img)
    [h,w]=size(img);
    [x,y]=find(img==0);
    Kcon=convhull(x,y);
    numPts=size(Kcon);
    conv_img(:,:,1)=img;
    conv_img(:,:,2)=img;
    conv_img(:,:,3)=img;
    
    %get the convex hull of the image
    for i=1:(numPts-1)
        vert0 = [x(Kcon(i)) y(Kcon(i))];
        vert1 = [x(Kcon(i+1)) y(Kcon(i+1))];
        vertLine_temp = DrawLine_DDA2d(vert0,vert1);
        numVexLine_temp = size(vertLine_temp,2);
        for l=1:numVexLine_temp
            conv_img(vertLine_temp(1,l),vertLine_temp(2,l), 2)=0;
            conv_img(vertLine_temp(1,l),vertLine_temp(2,l), 3)=0;

        end
    end

    %get the axis
    [p,S]=polyfit(x,y,1);
     for x1=1:h;
        y1=round(p(1)*x1+p(2));
        if y1 <= 0
            y1 = 1;
        end
     end

     %calculate the feature
    leep=p(1);
    point=p(2)/w;
    sum_pixels_left=0;
    sum_pixels_right=0;
    for i=1:h
        temp_sum_left=0;
        temp_sum_right=0;
        I=find(conv_img(i,:)==0);
        minI=min(I);
        maxI=max(I);
        y1=round(p(1)*i+p(2));
        if y1 <= 0
            y1 =1;
        end
        for j=minI:y1
            if conv_img(i,j)~=0
                temp_sum_left=temp_sum_left+1;
            end
        end
        sum_pixels_left=sum_pixels_left+temp_sum_left;
        for j=y1:maxI
            if conv_img(i,j)~=0
                temp_sum_right=temp_sum_right+1;
            end
        end
        sum_pixels_right=sum_pixels_right+temp_sum_right;
    end

    left_ratio=sum_pixels_left/(sum_pixels_left+sum_pixels_right);
    kd(1) = leep;
    kd(2) = point;
    kd(3) = left_ratio;
end