%return the convexity of the character image
%Author: Rongju Sun
%Email: rongjusun@gmail.com
%Date: Dec, 2014
%@Peking University, China

function ratio = fig_convexity(img)
    [h,w]=size(img);
    [x,y]=find(img==0);
    Kcon=convhull(x,y);
    numPts=size(Kcon);
    sum_pixels=0;
    conv_img(:,:,1)=img;
    conv_img(:,:,2)=img;
    conv_img(:,:,3)=img;

    for i=1:(numPts-1)
        vert0 = [x(Kcon(i)) y(Kcon(i))];
        vert1 = [x(Kcon(i+1)) y(Kcon(i+1))];
        vertLine_temp = DrawLine_DDA2d(vert0,vert1);
        
        numVexLine_temp = size(vertLine_temp,2);
        for l=1:numVexLine_temp
            img(vertLine_temp(1,l),vertLine_temp(2,l))=0;
            conv_img(vertLine_temp(1,l),vertLine_temp(2,l), 2)=0;
            conv_img(vertLine_temp(1,l),vertLine_temp(2,l), 3)=0;
        end
    end
    
    for i=1:h
        temp_sum=0;
        I=find(conv_img(i,:,1)==0);
        minI=min(I);
        maxI=max(I);
        for j=minI:maxI
            if conv_img(i,j)~=0
                temp_sum=temp_sum+1;
            end
        end
        sum_pixels=sum_pixels+temp_sum;
    end
    ratio=size(x,1)/sum_pixels;
end