%return the ratios of pixel distribution in quadrants
%Author: Rongju Sun
%Email: rongjusun@gmail.com
%Date: Dec, 2014
%@Peking University, China

function fig_fillin = fig_fillin(img)
    [h, w]=size(img);
    img = im2bw(img, 0.5);
    img_black = ones(h, w) - img;
    
    %rotate the image from 0 to 90 degree
    min_fill = 1;
    max_fill = 0;
    max_direction = -1;
    min_direction = -1;
    for rotate_angle = 0: 1: 90
       img_ro_black = imrotate(img_black, rotate_angle);
       
       img_ro = ~img_ro_black;
       
       %fill the image in rows
       [x, y] = find(img_ro == 0 );
        nPts = size(x, 1);
        img_ro = img_ro(min(x) : max(x), min(y) : max(y) );
        [h_ro, w_ro] = size(img_ro);
        clear img_h;
        img_h(:, :, 1) = img_ro;
        
        img_h(:, :, 2) = img_ro;
        img_h(:, :, 3) = img_ro;
        nPts_h = 0;
        for i = 1 : h_ro
            [Pts_x, Pts_y] = find(img_ro(i, :) == 0);
            for j =  min(Pts_y): max(Pts_y)
                if img_ro(i, j) ~= 0
                    img_h(i, j, 1) = 0;
                    img_h(i, j, 2) = 236;
                    img_h(i, j, 3) = 0;
                    nPts_h = nPts_h + 1;
                end
            end
        end
        fill_h = (nPts_h) /(nPts_h + nPts);

        if fill_h > max_fill
            max_fill = fill_h;
            max_angle = rotate_angle;
            max_direction = 1;
            max_fill_img = img_h;
        end
        
        %fill the image in columns
        clear img_s;
        img_s(:, :, 1) = img_ro;
        img_s(:, :, 2) = img_ro;
        img_s(:, :, 3) = img_ro;
        nPts_s = 0;
        for i = 1 : w_ro
            [Pts_x, Pts_y] = find(img_ro(:, i) == 0);
            for j =  min(Pts_x): max(Pts_x)
                if img_ro(j, i) ~= 0
                    img_s(j, i, 1) = 0;
                    img_s(j, i, 2) = 236;
                    img_s(j, i, 3) = 0;
                    nPts_s = nPts_s + 1;
                end
            end 
        end
        fill_s = (nPts_s) /(nPts_s + nPts);
        if fill_s > max_fill
            max_fill = fill_h;
            max_angle = rotate_angle;
            max_direction = 0;
            max_fill_img = img_s;
        end
    end
    fig_fillin = max_fill;
end