%return the rectangular linearity of an image
%Author: Rongju Sun
%Email: rongjusun@gmail.com
%Date: Dec, 2014
%@Peking University, China

function c = fig_rec_linearity(img)
    [x,y]=find(img==0);
    Xmax=max(x);
    Xmin=min(x);
    Ymax=max(y);
    Ymin=min(y);
    sum_rect=2*(Xmax-Xmin)+2*(Ymax-Ymin);
    Kcon=convhull(x,y);
    numPts=size(Kcon);
    sum_per=0;
     for i=1:(numPts-1)
        vert0 = [x(Kcon(i)) y(Kcon(i))];
        vert1 = [x(Kcon(i+1)) y(Kcon(i+1))];
        vert_sub=vert0-vert1;
        sum_per=sum_per+norm(vert_sub); 
     end
    c=sum_per/sum_rect;
end